diff -Naur newlib-1.19.0.orig/newlib/libc/include/stdint.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/stdint.h
--- newlib-1.19.0.orig/newlib/libc/include/stdint.h	2009-04-24 23:55:07.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/stdint.h	2011-05-17 07:25:06.772153437 +0200
@@ -33,7 +33,7 @@
 /* Check if "long" is 64bit or 32bit wide */
 #if __STDINT_EXP(LONG_MAX) > 0x7fffffff
 #define __have_long64 1
-#elif __STDINT_EXP(LONG_MAX) == 0x7fffffff && !defined(__SPU__)
+#elif __STDINT_EXP(LONG_MAX) == 0x7fffffff
 #define __have_long32 1
 #endif
 
@@ -49,14 +49,14 @@
 #define __int_least8_t_defined 1
 #endif
 
-#if __STDINT_EXP(SHRT_MAX) == 0x7fff
-typedef signed short int16_t;
-typedef unsigned short uint16_t;
-#define __int16_t_defined 1
-#elif __STDINT_EXP(INT_MAX) == 0x7fff
+#if __STDINT_EXP(INT_MAX) == 0x7fff
 typedef signed int int16_t;
 typedef unsigned int uint16_t;
 #define __int16_t_defined 1
+#elif __STDINT_EXP(SHRT_MAX) == 0x7fff
+typedef signed short int16_t;
+typedef unsigned short uint16_t;
+#define __int16_t_defined 1
 #elif __STDINT_EXP(SCHAR_MAX) == 0x7fff
 typedef signed char int16_t;
 typedef unsigned char uint16_t;
@@ -239,6 +239,29 @@
  * GCC doesn't provide an appropriate macro for [u]intptr_t
  * For now, use __PTRDIFF_TYPE__
  */
+#if defined(__SIZEOF_POINTER__)
+#if __SIZEOF_POINTER__ == 8
+  typedef int64_t intptr_t;
+  typedef uint64_t uintptr_t;
+#define INTPTR_MAX INT64_MAX
+#define INTPTR_MIN INT64_MIN
+#define UINTPTR_MAX UINT64_MAX
+#elif __SIZEOF_POINTER__ == 4
+  typedef int32_t intptr_t;
+  typedef uint32_t uintptr_t;
+#define INTPTR_MAX INT32_MAX
+#define INTPTR_MIN INT32_MIN
+#define UINTPTR_MAX UINT32_MAX
+#elif __SIZEOF_POINTER__ == 2
+  typedef int16_t intptr_t;
+  typedef uint16_t uintptr_t;
+#define INTPTR_MAX INT16_MAX
+#define INTPTR_MIN INT16_MIN
+#define UINTPTR_MAX UINT16_MAX
+#else
+#error cannot determine intptr_t
+#endif
+#else
 #if defined(__PTRDIFF_TYPE__)
 typedef signed __PTRDIFF_TYPE__ intptr_t;
 typedef unsigned __PTRDIFF_TYPE__ uintptr_t;
@@ -260,6 +283,7 @@
 #define INTPTR_MIN (-__STDINT_EXP(LONG_MAX) - 1)
 #define UINTPTR_MAX (__STDINT_EXP(LONG_MAX) * 2UL + 1)
 #endif
+#endif
 
 /* Limits of Specified-Width Integer Types */
 
@@ -408,6 +432,8 @@
 /* This must match size_t in stddef.h, currently long unsigned int */
 #ifdef __SIZE_MAX__
 #define SIZE_MAX __SIZE_MAX__
+#elif defined(__SIZEOF_SIZE_T__) && defined(__CHAR_BIT__)
+#define SIZE_MAX (((1UL << (__SIZEOF_SIZE_T__ * __CHAR_BIT__ - 1)) - 1) * 2 + 1)
 #else
 #define SIZE_MAX (__STDINT_EXP(LONG_MAX) * 2UL + 1)
 #endif
diff -Naur newlib-1.19.0.orig/newlib/libc/include/stdio.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/stdio.h
--- newlib-1.19.0.orig/newlib/libc/include/stdio.h	2010-02-26 10:41:43.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/stdio.h	2011-05-17 07:25:06.772153437 +0200
@@ -308,7 +308,7 @@
  * Routines in POSIX 1003.1:2001.
  */
 
-#ifndef __STRICT_ANSI__
+#if (!defined(__STRICT_ANSI__) || (__STDC_VERSION__ >= 199901L))
 #ifndef _REENT_ONLY
 FILE *	_EXFUN(fdopen, (int, const char *));
 #endif
diff -Naur newlib-1.19.0.orig/newlib/libc/include/stdlib.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/stdlib.h
--- newlib-1.19.0.orig/newlib/libc/include/stdlib.h	2010-07-19 20:21:11.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/stdlib.h	2011-05-17 07:25:06.772153437 +0200
@@ -38,7 +38,7 @@
   long rem; /* remainder */
 } ldiv_t;
 
-#ifndef __STRICT_ANSI__
+#if !defined(__STRICT_ANSI__) || (__STDC_VERSION__ >= 199901L)
 typedef struct
 {
   long long int quot; /* quotient */
@@ -63,13 +63,12 @@
 int	_EXFUN(abs,(int));
 int	_EXFUN(atexit,(_VOID (*__func)(_VOID)));
 double	_EXFUN(atof,(const char *__nptr));
-#ifndef __STRICT_ANSI__
-float	_EXFUN(atoff,(const char *__nptr));
-#endif
 int	_EXFUN(atoi,(const char *__nptr));
-int	_EXFUN(_atoi_r,(struct _reent *, const char *__nptr));
 long	_EXFUN(atol,(const char *__nptr));
+#ifndef __STRICT_ANSI__
+int	_EXFUN(_atoi_r,(struct _reent *, const char *__nptr));
 long	_EXFUN(_atol_r,(struct _reent *, const char *__nptr));
+#endif /* ! __STRICT_ANSI__ */
 _PTR	_EXFUN(bsearch,(const _PTR __key,
 		       const _PTR __base,
 		       size_t __nmemb,
@@ -80,10 +79,10 @@
 _VOID	_EXFUN(exit,(int __status) _ATTRIBUTE ((noreturn)));
 _VOID	_EXFUN_NOTHROW(free,(_PTR));
 char *  _EXFUN(getenv,(const char *__string));
+#ifndef __STRICT_ANSI__
 char *	_EXFUN(_getenv_r,(struct _reent *, const char *__string));
 char *	_EXFUN(_findenv,(_CONST char *, int *));
 char *	_EXFUN(_findenv_r,(struct _reent *, _CONST char *, int *));
-#ifndef __STRICT_ANSI__
 extern char *suboptarg;			/* getsubopt(3) external variable */
 int	_EXFUN(getsubopt,(char **, char * const *, char **));
 #endif
@@ -91,16 +90,16 @@
 ldiv_t	_EXFUN(ldiv,(long __numer, long __denom));
 _PTR	_EXFUN_NOTHROW(malloc,(size_t __size));
 int	_EXFUN(mblen,(const char *, size_t));
-int	_EXFUN(_mblen_r,(struct _reent *, const char *, size_t, _mbstate_t *));
 int	_EXFUN(mbtowc,(wchar_t *, const char *, size_t));
-int	_EXFUN(_mbtowc_r,(struct _reent *, wchar_t *, const char *, size_t, _mbstate_t *));
 int	_EXFUN(wctomb,(char *, wchar_t));
-int	_EXFUN(_wctomb_r,(struct _reent *, char *, wchar_t, _mbstate_t *));
 size_t	_EXFUN(mbstowcs,(wchar_t *, const char *, size_t));
-size_t	_EXFUN(_mbstowcs_r,(struct _reent *, wchar_t *, const char *, size_t, _mbstate_t *));
 size_t	_EXFUN(wcstombs,(char *, const wchar_t *, size_t));
-size_t	_EXFUN(_wcstombs_r,(struct _reent *, char *, const wchar_t *, size_t, _mbstate_t *));
 #ifndef __STRICT_ANSI__
+int	_EXFUN(_mblen_r,(struct _reent *, const char *, size_t, _mbstate_t *));
+int	_EXFUN(_mbtowc_r,(struct _reent *, wchar_t *, const char *, size_t, _mbstate_t *));
+int	_EXFUN(_wctomb_r,(struct _reent *, char *, wchar_t, _mbstate_t *));
+size_t	_EXFUN(_mbstowcs_r,(struct _reent *, wchar_t *, const char *, size_t, _mbstate_t *));
+size_t	_EXFUN(_wcstombs_r,(struct _reent *, char *, const wchar_t *, size_t, _mbstate_t *));
 #ifndef _REENT_ONLY
 char *	_EXFUN(mkdtemp,(char *));
 int	_EXFUN(mkostemp,(char *, int));
@@ -133,10 +132,11 @@
 # endif
 #endif
 long	_EXFUN(strtol,(const char *__n, char **__end_PTR, int __base));
-long	_EXFUN(_strtol_r,(struct _reent *,const char *__n, char **__end_PTR, int __base));
 unsigned long _EXFUN(strtoul,(const char *__n, char **__end_PTR, int __base));
+#ifndef __STRICT_ANSI__
 unsigned long _EXFUN(_strtoul_r,(struct _reent *,const char *__n, char **__end_PTR, int __base));
-
+long	_EXFUN(_strtol_r,(struct _reent *,const char *__n, char **__end_PTR, int __base));
+#endif /* !__STRICT_ANSI__ */
 int	_EXFUN(system,(const char *__string));
 
 #ifndef __STRICT_ANSI__
@@ -163,33 +163,39 @@
 int	_EXFUN(rand_r,(unsigned *__seed));
 
 double _EXFUN(drand48,(_VOID));
-double _EXFUN(_drand48_r,(struct _reent *));
 double _EXFUN(erand48,(unsigned short [3]));
-double _EXFUN(_erand48_r,(struct _reent *, unsigned short [3]));
 long   _EXFUN(jrand48,(unsigned short [3]));
-long   _EXFUN(_jrand48_r,(struct _reent *, unsigned short [3]));
 _VOID  _EXFUN(lcong48,(unsigned short [7]));
-_VOID  _EXFUN(_lcong48_r,(struct _reent *, unsigned short [7]));
 long   _EXFUN(lrand48,(_VOID));
-long   _EXFUN(_lrand48_r,(struct _reent *));
 long   _EXFUN(mrand48,(_VOID));
-long   _EXFUN(_mrand48_r,(struct _reent *));
 long   _EXFUN(nrand48,(unsigned short [3]));
-long   _EXFUN(_nrand48_r,(struct _reent *, unsigned short [3]));
 unsigned short *
        _EXFUN(seed48,(unsigned short [3]));
+_VOID  _EXFUN(srand48,(long));
+long long _EXFUN(atoll,(const char *__nptr));
+#ifndef __STRICT_ANSI__
+double _EXFUN(_drand48_r,(struct _reent *));
+double _EXFUN(_erand48_r,(struct _reent *, unsigned short [3]));
+long   _EXFUN(_jrand48_r,(struct _reent *, unsigned short [3]));
+_VOID  _EXFUN(_lcong48_r,(struct _reent *, unsigned short [7]));
+long   _EXFUN(_lrand48_r,(struct _reent *));
+long   _EXFUN(_mrand48_r,(struct _reent *));
+long   _EXFUN(_nrand48_r,(struct _reent *, unsigned short [3]));
 unsigned short *
        _EXFUN(_seed48_r,(struct _reent *, unsigned short [3]));
-_VOID  _EXFUN(srand48,(long));
 _VOID  _EXFUN(_srand48_r,(struct _reent *, long));
-long long _EXFUN(atoll,(const char *__nptr));
 long long _EXFUN(_atoll_r,(struct _reent *, const char *__nptr));
+#endif /* ! __STRICT_ANSI__ */
+#if !defined(__STRICT_ANSI__) || (__STDC_VERSION__ >= 199901L)
 long long _EXFUN(llabs,(long long));
 lldiv_t	_EXFUN(lldiv,(long long __numer, long long __denom));
 long long _EXFUN(strtoll,(const char *__n, char **__end_PTR, int __base));
-long long _EXFUN(_strtoll_r,(struct _reent *, const char *__n, char **__end_PTR, int __base));
 unsigned long long _EXFUN(strtoull,(const char *__n, char **__end_PTR, int __base));
+#endif
+#ifndef __STRICT_ANSI__
+long long _EXFUN(_strtoll_r,(struct _reent *, const char *__n, char **__end_PTR, int __base));
 unsigned long long _EXFUN(_strtoull_r,(struct _reent *, const char *__n, char **__end_PTR, int __base));
+#endif /* ! __STRICT_ANSI__ */
 
 #ifndef __CYGWIN__
 _VOID	_EXFUN(cfree,(_PTR));
@@ -203,6 +209,7 @@
 
 #endif /* ! __STRICT_ANSI__ */
 
+#ifndef __STRICT_ANSI__
 char *	_EXFUN(_dtoa_r,(struct _reent *, double, int, int, int *, int*, char**));
 #ifndef __CYGWIN__
 _PTR	_EXFUN_NOTHROW(_malloc_r,(struct _reent *, size_t));
@@ -214,6 +221,7 @@
 int	_EXFUN(_system_r,(struct _reent *, const char *));
 
 _VOID	_EXFUN(__eprintf,(const char *, const char *, unsigned int, const char *));
+#endif /* ! __STRICT_ANSI__ */
 
 /* On platforms where long double equals double.  */
 #ifdef _LDBL_EQ_DBL
diff -Naur newlib-1.19.0.orig/newlib/libc/include/string.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/string.h
--- newlib-1.19.0.orig/newlib/libc/include/string.h	2008-06-18 17:27:27.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/string.h	2011-05-17 07:25:06.772153437 +0200
@@ -9,6 +9,7 @@
 
 #include "_ansi.h"
 #include <sys/reent.h>
+#include <sys/cdefs.h>
 
 #define __need_size_t
 #include <stddef.h>
@@ -49,52 +50,42 @@
 #ifndef __STRICT_ANSI__
 char 	*_EXFUN(strtok_r,(char *, const char *, char **));
 
-int	 _EXFUN(bcmp,(const void *, const void *, size_t));
-void	 _EXFUN(bcopy,(const void *, void *, size_t));
-void	 _EXFUN(bzero,(void *, size_t));
-int	 _EXFUN(ffs,(int));
-char 	*_EXFUN(index,(const char *, int));
 _PTR	 _EXFUN(memccpy,(_PTR, const _PTR, int, size_t));
 _PTR	 _EXFUN(mempcpy,(_PTR, const _PTR, size_t));
 _PTR	 _EXFUN(memmem, (const _PTR, size_t, const _PTR, size_t));
-char 	*_EXFUN(rindex,(const char *, int));
 char 	*_EXFUN(stpcpy,(char *, const char *));
 char 	*_EXFUN(stpncpy,(char *, const char *, size_t));
-int	 _EXFUN(strcasecmp,(const char *, const char *));
 char	*_EXFUN(strcasestr,(const char *, const char *));
+char 	*_EXFUN(strchrnul,(const char *, int));
 char 	*_EXFUN(strdup,(const char *));
 char 	*_EXFUN(_strdup_r,(struct _reent *, const char *));
 char 	*_EXFUN(strndup,(const char *, size_t));
 char 	*_EXFUN(_strndup_r,(struct _reent *, const char *, size_t));
-char 	*_EXFUN(strerror_r,(int, char *, size_t));
+/* There are two common strerror_r variants.  If you request
+   _GNU_SOURCE, you get the GNU version; otherwise you get the POSIX
+   version.  POSIX requires that #undef strerror_r will still let you
+   invoke the underlying function, but that requires gcc support.  */
+#ifdef _GNU_SOURCE
+char    *_EXFUN(strerror_r,(int, char *, size_t));
+#else
+# ifdef __GNUC__
+int      _EXFUN(strerror_r,(int, char *, size_t)) __asm__ (__ASMNAME ("__xpg_strerror_r"));
+# else
+int      _EXFUN(__xpg_strerror_r,(int, char *, size_t));
+#  define strerror_r __xpg_strerror_r
+# endif
+#endif
 size_t	 _EXFUN(strlcat,(char *, const char *, size_t));
 size_t	 _EXFUN(strlcpy,(char *, const char *, size_t));
-int	 _EXFUN(strncasecmp,(const char *, const char *, size_t));
 size_t	 _EXFUN(strnlen,(const char *, size_t));
 char 	*_EXFUN(strsep,(char **, const char *));
 char	*_EXFUN(strlwr,(char *));
 char	*_EXFUN(strupr,(char *));
+char	*_EXFUN(strsignal, (int __signo));
 #ifdef __CYGWIN__
-#ifndef DEFS_H	/* Kludge to work around problem compiling in gdb */
-char  *_EXFUN(strsignal, (int __signo));
-#endif
 int     _EXFUN(strtosigno, (const char *__name));
 #endif
 
-/* These function names are used on Windows and perhaps other systems.  */
-#ifndef strcmpi
-#define strcmpi strcasecmp
-#endif
-#ifndef stricmp
-#define stricmp strcasecmp
-#endif
-#ifndef strncmpi
-#define strncmpi strncasecmp
-#endif
-#ifndef strnicmp
-#define strnicmp strncasecmp
-#endif
-
 #endif /* ! __STRICT_ANSI__ */
 
 #include <sys/string.h>
diff -Naur newlib-1.19.0.orig/newlib/libc/include/sys/cdefs.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/sys/cdefs.h
--- newlib-1.19.0.orig/newlib/libc/include/sys/cdefs.h	2002-06-20 21:51:24.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/sys/cdefs.h	2011-05-17 07:25:06.773153454 +0200
@@ -58,6 +58,27 @@
 #define __DOTS    	, ...
 #define __THROW
 
+/*
+ * The __CONCAT macro is used to concatenate parts of symbol names, e.g.
+ * with "#define OLD(foo) __CONCAT(old,foo)", OLD(foo) produces oldfoo.
+ * The __CONCAT macro is a bit tricky to use if it must work in non-ANSI
+ * mode -- there must be no spaces between its arguments, and for nested
+ * __CONCAT's, all the __CONCAT's must be at the left.  __CONCAT can also
+ * concatenate double-quoted strings produced by the __STRING macro, but
+ * this only works with ANSI C.
+ *
+ * __XSTRING is like __STRING, but it expands any macros in its argument
+ * first.  It is only available with ANSI C.
+ */
+#define __CONCAT1(x,y)  x ## y
+#define __CONCAT(x,y)   __CONCAT1(x,y)
+#define __STRING(x)     #x              /* stringify without expanding x */
+#define __XSTRING(x)    __STRING(x)     /* expand x, then stringify */
+
+#ifdef __GNUC__
+# define __ASMNAME(cname)  __XSTRING (__USER_LABEL_PREFIX__) cname
+#endif
+
 #define __ptr_t void *
 #define __long_double_t  long double
 
diff -Naur newlib-1.19.0.orig/newlib/libc/include/sys/_default_fcntl.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/sys/_default_fcntl.h
--- newlib-1.19.0.orig/newlib/libc/include/sys/_default_fcntl.h	2010-01-14 19:49:13.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/sys/_default_fcntl.h	2011-05-17 07:25:06.773153454 +0200
@@ -51,8 +51,6 @@
 #define O_BINARY	_FBINARY
 #define O_TEXT		_FTEXT
 #define O_NOINHERIT	_FNOINHERIT
-/* O_CLOEXEC is the Linux equivalent to O_NOINHERIT */
-#define O_CLOEXEC	_FNOINHERIT
 
 /* The windows header files define versions with a leading underscore.  */
 #define _O_RDONLY	O_RDONLY
@@ -124,9 +122,6 @@
 #define	F_CNVT 		12	/* Convert a fhandle to an open fd */
 #define	F_RSETLKW 	13	/* Set or Clear remote record-lock(Blocking) */
 #endif	/* !_POSIX_SOURCE */
-#ifdef __CYGWIN__
-#define	F_DUPFD_CLOEXEC	14	/* As F_DUPFD, but set close-on-exec flag */
-#endif
 
 /* fcntl(2) flags (l_type field of flock structure) */
 #define	F_RDLCK		1	/* read lock */
diff -Naur newlib-1.19.0.orig/newlib/libc/include/sys/features.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/sys/features.h
--- newlib-1.19.0.orig/newlib/libc/include/sys/features.h	2010-08-09 10:29:22.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/sys/features.h	2011-05-17 07:25:06.777153516 +0200
@@ -15,7 +15,7 @@
  *  OR WARRANTY OF ANY KIND CONCERNING THE MERCHANTABILITY OF THIS
  *  SOFTWARE OR ITS FITNESS FOR ANY PARTICULAR PURPOSE.
  *
- *  $Id: features.h,v 1.22 2010/08/09 08:29:22 corinna Exp $
+ *  $Id: features.h,v 1.26 2011/05/16 22:35:10 yselkowitz Exp $
  */
 
 #ifndef _SYS_FEATURES_H
@@ -103,7 +103,7 @@
 /* #define _POSIX_BARRIERS			    -1 */
 #define _POSIX_CHOWN_RESTRICTED			     1
 /* #define _POSIX_CLOCK_SELECTION		    -1 */
-/* #define _POSIX_CPUTIME			    -1 */
+#define _POSIX_CPUTIME			    	200112L
 #define _POSIX_FSYNC				200112L
 #define _POSIX_IPV6				200112L
 #define _POSIX_JOB_CONTROL			     1
@@ -125,12 +125,12 @@
 #define _POSIX_SHARED_MEMORY_OBJECTS		200112L 
 #define _POSIX_SHELL				     1
 /* #define _POSIX_SPAWN				    -1 */
-/* #define _POSIX_SPIN_LOCKS			    -1 */
+#define _POSIX_SPIN_LOCKS			    200112L
 /* #define _POSIX_SPORADIC_SERVER		    -1 */
 #define _POSIX_SYNCHRONIZED_IO			200112L
-/* #define _POSIX_THREAD_ATTR_STACKADDR		    -1 */
+#define _POSIX_THREAD_ATTR_STACKADDR		200112L
 #define _POSIX_THREAD_ATTR_STACKSIZE		200112L
-/* #define _POSIX_THREAD_CPUTIME		    -1 */
+#define _POSIX_THREAD_CPUTIME			200112L
 /* #define _POSIX_THREAD_PRIO_INHERIT		    -1 */
 /* #define _POSIX_THREAD_PRIO_PROTECT		    -1 */
 #define _POSIX_THREAD_PRIORITY_SCHEDULING	200112L
@@ -178,6 +178,12 @@
 /* #define _XOPEN_UNIX				    -1 */
 
 #endif /* !__STRICT_ANSI__ || __cplusplus || __STDC_VERSION__ >= 199901L */
+
+/* The value corresponds to UNICODE version 4.0, which is the version
+   supported by XP.  Newlib supports 5.2 (2011) but so far Cygwin needs
+   the MS conversions for double-byte charsets. */
+#define __STDC_ISO_10646__ 200305L
+
 #endif /* __CYGWIN__ */
 
 /* Per the permission given in POSIX.1-2008 section 2.2.1, define
diff -Naur newlib-1.19.0.orig/newlib/libc/include/sys/signal.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/sys/signal.h
--- newlib-1.19.0.orig/newlib/libc/include/sys/signal.h	2009-10-13 19:31:49.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/sys/signal.h	2011-05-17 07:25:06.777153516 +0200
@@ -76,11 +76,12 @@
  *
  *  (1) Routines stored in sa_handler should take a single int as
  *      their argument although the POSIX standard does not require this.
+ *      This is not longer true since at least POSIX.1-2008
  *  (2) The fields sa_handler and sa_sigaction may overlap, and a conforming
  *      application should not use both simultaneously.
  */
 
-typedef void (*_sig_func_ptr)();
+typedef void (*_sig_func_ptr)(int);
 
 struct sigaction {
   int         sa_flags;       /* Special flags to affect behavior of signal */
diff -Naur newlib-1.19.0.orig/newlib/libc/include/sys/types.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/sys/types.h
--- newlib-1.19.0.orig/newlib/libc/include/sys/types.h	2010-12-08 15:44:06.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/sys/types.h	2011-05-17 07:25:06.777153516 +0200
@@ -98,6 +98,7 @@
 
 typedef	unsigned short	ushort;		/* System V compatibility */
 typedef	unsigned int	uint;		/* System V compatibility */
+typedef	unsigned long	ulong;		/* System V compatibility */
 # endif	/*!_POSIX_SOURCE */
 
 #ifndef __clock_t_defined
@@ -462,13 +463,13 @@
 
 /* POSIX Spin Lock Types */
 
+#if !defined (__CYGWIN__)
 #if defined(_POSIX_SPIN_LOCKS)
 typedef __uint32_t pthread_spinlock_t;        /* POSIX Spin Lock Object */
 #endif /* defined(_POSIX_SPIN_LOCKS) */
 
 /* POSIX Reader/Writer Lock Types */
 
-#if !defined (__CYGWIN__)
 #if defined(_POSIX_READER_WRITER_LOCKS)
 typedef __uint32_t pthread_rwlock_t;         /* POSIX RWLock Object */
 typedef struct {
diff -Naur newlib-1.19.0.orig/newlib/libc/include/time.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/time.h
--- newlib-1.19.0.orig/newlib/libc/include/time.h	2008-10-16 23:53:58.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/time.h	2011-05-17 07:25:06.777153516 +0200
@@ -212,7 +212,7 @@
    the identifier of the CPU_time clock associated with the PROCESS
    making the function call.  */
 
-#define CLOCK_PROCESS_CPUTIME (clockid_t)2
+#define CLOCK_PROCESS_CPUTIME_ID (clockid_t)2
 
 #endif
 
@@ -222,7 +222,7 @@
     the identifier of the CPU_time clock associated with the THREAD
     making the function call.  */
 
-#define CLOCK_THREAD_CPUTIME (clockid_t)3
+#define CLOCK_THREAD_CPUTIME_ID (clockid_t)3
 
 #endif
 
diff -Naur newlib-1.19.0.orig/newlib/libc/include/wchar.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/wchar.h
--- newlib-1.19.0.orig/newlib/libc/include/wchar.h	2009-10-15 10:23:27.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/include/wchar.h	2011-05-17 07:25:06.778153530 +0200
@@ -16,6 +16,9 @@
 /* For _mbstate_t definition. */
 #include <sys/_types.h>
 
+/* For __STDC_ISO_10646__ */
+#include <sys/features.h>
+
 #ifndef NULL
 #define NULL	0
 #endif
diff -Naur newlib-1.19.0.orig/newlib/libc/locale/lmessages.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/locale/lmessages.c
--- newlib-1.19.0.orig/newlib/libc/locale/lmessages.c	2010-04-28 11:59:37.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/locale/lmessages.c	2011-05-17 07:25:06.778153530 +0200
@@ -41,7 +41,7 @@
 	"^[yY]" ,	/* yesexpr */
 	"^[nN]" ,	/* noexpr */
 	"yes" , 	/* yesstr */
-	"no"		/* nostr */
+	"no" ,		/* nostr */
 	"ASCII"		/* codeset */
 #ifdef __HAVE_LOCALE_INFO_EXTENDED__
 	, L"^[yY]" ,	/* wyesexpr */
diff -Naur newlib-1.19.0.orig/newlib/libc/locale/lmessages.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/locale/lmessages.h
--- newlib-1.19.0.orig/newlib/libc/locale/lmessages.h	2010-04-28 11:59:37.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/locale/lmessages.h	2011-05-17 07:25:06.778153530 +0200
@@ -50,7 +50,7 @@
 };
 
 struct lc_messages_T *__get_current_messages_locale(void);
-int __numeric_load_locale(const char *, void *, const char *);
+int __messages_load_locale(const char *, void *, const char *);
 
 __END_DECLS
 
diff -Naur newlib-1.19.0.orig/newlib/libc/locale/locale.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/locale/locale.c
--- newlib-1.19.0.orig/newlib/libc/locale/locale.c	2010-11-19 11:02:36.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/locale/locale.c	2011-05-17 07:25:06.778153530 +0200
@@ -182,6 +182,7 @@
 #include "lmonetary.h"
 #include "lnumeric.h"
 #include "lctype.h"
+#include "timelocal.h"
 #include "../stdlib/local.h"
 
 #define _LC_LAST      7
@@ -235,7 +236,11 @@
 static char current_categories[_LC_LAST][ENCODING_LEN + 1] = {
     "C",
     "C",
+#ifdef __CYGWIN__ /* Cygwin starts with LC_CTYPE set to "C.UTF-8". */
+    "C.UTF-8",
+#else
     "C",
+#endif
     "C",
     "C",
     "C",
@@ -255,13 +260,12 @@
 
 #endif /* _MB_CAPABLE */
 
-#if 0 /*def __CYGWIN__  TODO: temporarily(?) disable C == UTF-8 */
+#ifdef __CYGWIN__
 static char lc_ctype_charset[ENCODING_LEN + 1] = "UTF-8";
-static char lc_message_charset[ENCODING_LEN + 1] = "UTF-8";
 #else
 static char lc_ctype_charset[ENCODING_LEN + 1] = "ASCII";
-static char lc_message_charset[ENCODING_LEN + 1] = "ASCII";
 #endif
+static char lc_message_charset[ENCODING_LEN + 1] = "ASCII";
 static int lc_ctype_cjk_lang = 0;
 
 char *
@@ -432,7 +436,7 @@
 #ifdef _MB_CAPABLE
 #ifdef __CYGWIN__
 extern void __set_charset_from_locale (const char *locale, char *charset);
-extern int __set_locale_from_locale_alias (const char *, char *);
+extern char *__set_locale_from_locale_alias (const char *, char *);
 extern int __collate_load_locale (const char *, void *, const char *);
 #endif /* __CYGWIN__ */
 
@@ -495,11 +499,7 @@
   if (!strcmp (locale, "POSIX"))
     strcpy (locale, "C");
   if (!strcmp (locale, "C"))				/* Default "C" locale */
-#if 0 /*def __CYGWIN__  TODO: temporarily(?) disable C == UTF-8 */
-    strcpy (charset, "UTF-8");
-#else
     strcpy (charset, "ASCII");
-#endif
   else if (locale[0] == 'C'
 	   && (locale[1] == '-'		/* Old newlib style */
 	       || locale[1] == '.'))	/* Extension for the C locale to allow
@@ -952,7 +952,7 @@
 _DEFUN_VOID(__locale_msgcharset)
 {
 #ifdef __HAVE_LOCALE_INFO__
-  return __get_current_messages_locale ()->codeset;
+  return (char *) __get_current_messages_locale ()->codeset;
 #else
   return lc_message_charset;
 #endif
@@ -972,21 +972,21 @@
   if (__nlocale_changed)
     {
       struct lc_numeric_T *n = __get_current_numeric_locale ();
-      lconv.decimal_point = n->decimal_point;
-      lconv.thousands_sep = n->thousands_sep;
-      lconv.grouping = n->grouping;
+      lconv.decimal_point = (char *) n->decimal_point;
+      lconv.thousands_sep = (char *) n->thousands_sep;
+      lconv.grouping = (char *) n->grouping;
       __nlocale_changed = 0;
     }
   if (__mlocale_changed)
     {
       struct lc_monetary_T *m = __get_current_monetary_locale ();
-      lconv.int_curr_symbol = m->int_curr_symbol;
-      lconv.currency_symbol = m->currency_symbol;
-      lconv.mon_decimal_point = m->mon_decimal_point;
-      lconv.mon_thousands_sep = m->mon_thousands_sep;
-      lconv.mon_grouping = m->mon_grouping;
-      lconv.positive_sign = m->positive_sign;
-      lconv.negative_sign = m->negative_sign;
+      lconv.int_curr_symbol = (char *) m->int_curr_symbol;
+      lconv.currency_symbol = (char *) m->currency_symbol;
+      lconv.mon_decimal_point = (char *) m->mon_decimal_point;
+      lconv.mon_thousands_sep = (char *) m->mon_thousands_sep;
+      lconv.mon_grouping = (char *) m->mon_grouping;
+      lconv.positive_sign = (char *) m->positive_sign;
+      lconv.negative_sign = (char *) m->negative_sign;
       lconv.int_frac_digits = m->int_frac_digits[0];
       lconv.frac_digits = m->frac_digits[0];
       lconv.p_cs_precedes = m->p_cs_precedes[0];
diff -Naur newlib-1.19.0.orig/newlib/libc/machine/frv/setjmp.S newlib-1.19.0-rtems4.11-20110517/newlib/libc/machine/frv/setjmp.S
--- newlib-1.19.0.orig/newlib/libc/machine/frv/setjmp.S	2002-06-18 23:20:28.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/machine/frv/setjmp.S	2011-05-17 07:25:06.779153544 +0200
@@ -123,4 +123,4 @@
 	cmov	gr9, gr8, cc4, 1
 	ret
 .Lend2:
-	.size	EXT(longjmp),.Lend2-EXT(longjmp2)
+	.size	EXT(longjmp),.Lend2-EXT(longjmp)
diff -Naur newlib-1.19.0.orig/newlib/libc/machine/m68k/memcpy.S newlib-1.19.0-rtems4.11-20110517/newlib/libc/machine/m68k/memcpy.S
--- newlib-1.19.0.orig/newlib/libc/machine/m68k/memcpy.S	2010-02-08 18:24:22.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/machine/m68k/memcpy.S	2011-05-17 07:25:06.779153544 +0200
@@ -15,7 +15,7 @@
 
 #include "m68kasm.h"
 
-#if defined (__mcoldfire__) || defined (__mc68010__) || defined (__mc68020__) || defined (__mc68030__) || defined (__mc68040__) || defined (__mc68060__)
+#if defined (__mcoldfire__) || defined (__mcpu32__) || defined (__mc68010__) || defined (__mc68020__) || defined (__mc68030__) || defined (__mc68040__) || defined (__mc68060__)
 # define MISALIGNED_OK 1
 #else
 # define MISALIGNED_OK 0
diff -Naur newlib-1.19.0.orig/newlib/libc/machine/mips/strlen.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/machine/mips/strlen.c
--- newlib-1.19.0.orig/newlib/libc/machine/mips/strlen.c	2002-03-14 03:41:43.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/machine/mips/strlen.c	2011-05-17 07:25:06.779153544 +0200
@@ -60,6 +60,9 @@
 	"	addiu	$2,$4,1\n"
 	"\n"
 	"1:	lbu	$3,0($4)\n"
+#if defined(_R3000)
+	"	nop	\n"
+#endif
 	"	bnez	$3,1b\n"
 	"	addiu	$4,$4,1\n"
 	"\n"
diff -Naur newlib-1.19.0.orig/newlib/libc/machine/powerpc/Makefile.am newlib-1.19.0-rtems4.11-20110517/newlib/libc/machine/powerpc/Makefile.am
--- newlib-1.19.0.orig/newlib/libc/machine/powerpc/Makefile.am	2007-05-24 19:33:35.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/machine/powerpc/Makefile.am	2011-05-17 07:25:06.779153544 +0200
@@ -10,7 +10,7 @@
 
 AM_CFLAGS = -I $(srcdir)/../../stdio -I $(srcdir)/../../stdlib
 
-lib_a_SOURCES = setjmp.S times.c
+lib_a_SOURCES = setjmp.S
 lib_a_CCASFLAGS=$(AM_CCASFLAGS)
 lib_a_CFLAGS=$(AM_CFLAGS)
 lib_a_LIBADD = @extra_objs@
diff -Naur newlib-1.19.0.orig/newlib/libc/Makefile.am newlib-1.19.0-rtems4.11-20110517/newlib/libc/Makefile.am
--- newlib-1.19.0.orig/newlib/libc/Makefile.am	2010-05-07 01:25:16.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/Makefile.am	2011-05-17 07:25:06.767153366 +0200
@@ -36,6 +36,8 @@
 
 if HAVE_XDR_DIR
 XDR_SUBDIR = xdr
+rpcincludedir = $(tooldir)
+nobase_rpcinclude_HEADERS = include/rpc/xdr.h include/rpc/types.h
 endif
 
 # The order of SUBDIRS is important for the integrated documentation.
@@ -140,8 +142,7 @@
 	locale/stmp-def \
 	reent/stmp-def \
 	$(LIBC_EXTRA_DEF) \
-	misc/stmp-def \
-	posix/stmp-def
+	misc/stmp-def
 
 libc.info: sigset.texi extra.texi stdio64.texi posix.texi iconvset.texi \
 	targetdep.tex $(SUBDEFS)
diff -Naur newlib-1.19.0.orig/newlib/libc/misc/__dprintf.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/misc/__dprintf.c
--- newlib-1.19.0.orig/newlib/libc/misc/__dprintf.c	2008-12-11 18:27:55.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/misc/__dprintf.c	2011-05-17 07:25:06.780153559 +0200
@@ -5,6 +5,7 @@
 */
 
 #include <_ansi.h>
+#include <stdint.h>
 #include "ctype.h"
 #include "reent.h"
 #include "string.h"
@@ -131,7 +132,7 @@
 	      write_string (unctrl (c));
 	      break;
 	    case 'p' :
-	      l = (_POINTER_INT) va_arg (args, char *);
+	      l = (intptr_t) va_arg (args, char *);
 	      print_number (16, 1, l);
 	      break;
 	    case 'd' :
diff -Naur newlib-1.19.0.orig/newlib/libc/misc/ffs.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/misc/ffs.c
--- newlib-1.19.0.orig/newlib/libc/misc/ffs.c	2003-06-06 21:57:51.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/misc/ffs.c	2011-05-17 07:25:06.780153559 +0200
@@ -6,9 +6,11 @@
 	ffs
 
 ANSI_SYNOPSIS
+	#include <strings.h>
 	int ffs(int <[word]>);
 
 TRAD_SYNOPSIS
+	#include <strings.h>
 	int ffs(<[word]>);
 
 DESCRIPTION
@@ -24,7 +26,7 @@
 
 No supporting OS subroutines are required.  */
 
-#include <_ansi.h>
+#include <strings.h>
 
 int
 _DEFUN(ffs, (word),
diff -Naur newlib-1.19.0.orig/newlib/libc/posix/readdir.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/posix/readdir.c
--- newlib-1.19.0.orig/newlib/libc/posix/readdir.c	2003-06-06 21:57:51.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/posix/readdir.c	2011-05-17 07:25:06.780153559 +0200
@@ -37,6 +37,7 @@
 static char sccsid[] = "@(#)readdir.c	5.7 (Berkeley) 6/1/90";
 #endif /* LIBC_SCCS and not lint */
 
+#include <stdint.h>
 #include <dirent.h>
 
 extern int getdents (int fd, void *dp, int count);
@@ -75,7 +76,7 @@
       continue;
     }
     dp = (struct dirent *)(dirp->dd_buf + dirp->dd_loc);
-    if ((int)dp & 03) {	/* bogus pointer check */
+    if ((intptr_t)dp & 03) {	/* bogus pointer check */
 #ifdef HAVE_DD_LOCK
       __lock_release_recursive(dirp->dd_lock);
 #endif
diff -Naur newlib-1.19.0.orig/newlib/libc/search/db_local.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/search/db_local.h
--- newlib-1.19.0.orig/newlib/libc/search/db_local.h	2010-03-05 09:55:15.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/search/db_local.h	2011-05-17 07:25:06.780153559 +0200
@@ -102,11 +102,11 @@
 typedef struct __db {
 	DBTYPE type;			/* Underlying db type. */
 	int (*close)(struct __db *);
-	int (*del)(const struct __db *, const DBT *, u_int);
-	int (*get)(const struct __db *, const DBT *, DBT *, u_int);
-	int (*put)(const struct __db *, DBT *, const DBT *, u_int);
-	int (*seq)(const struct __db *, DBT *, DBT *, u_int);
-	int (*sync)(const struct __db *, u_int);
+	int (*del)(const struct __db *, const DBT *, __uint32_t);
+	int (*get)(const struct __db *, const DBT *, DBT *, __uint32_t);
+	int (*put)(const struct __db *, DBT *, const DBT *, __uint32_t);
+	int (*seq)(const struct __db *, DBT *, DBT *, __uint32_t);
+	int (*sync)(const struct __db *, __uint32_t);
 	void *internal;			/* Access method private. */
 	int (*fd)(const struct __db *);
 } DB;
